// Original code by TAKAHASHI Shuhei <pcb@pcbsoft.net>
// This code is licensed under NYSL ver. 0.9982.
// See LICENSE.txt for details.

#include "common.h"


// TCP\Pbg쐬Aڑ
//		p1	\Pbgnhi[ϐ
//		p2	ڑT[o[
//		p3	ڑ|[g
EXPORT BOOL WINAPI tcpopen(int *p1, char *p2, int p3, int p4)
{
	*p1 = 0;
	if ( InitWSA() ) return -1;		// WinSockG[

	/*  `FbNT  */
	if (p3 <= 0 || p3 >= 65536) return -3;

	THREADLIST *tl;
	tl = CreateSocketThread(ST_TCP);
	if (tl == NULL)
		return -2;			//	ThreadG[

	SendMessage(tl->hWnd, WM_CONNECT, (WPARAM)p3, (LPARAM)p2);
	*p1 = (int)tl;
	return 0;
}




// TCP\Pbgڑς݂ǂ擾
//		p1,p2	hybrid
EXPORT BOOL WINAPI tcpiscon(int p1, int p2, int p3, int p4)
{
	THREADLIST *tl = (LPTHREADLIST)p1;
	THREADINFO *ti;
	if (! IsSocketHandle(tl, ST_TCP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -2;

	int ret;
	ti = tl->ti;

	ti->Lock();
	if ( ti->tcp.bAvailable && ti->err == 0 )
		ret = -1;		//	ڑς
	else if ( ti->err != 0 )
		ret = -2;		//	G[
	else
		ret = 0;		//	ڑ
	ti->Unlock();

	return ret;
}




// TCP\PbgRead
//		p1	ϐ
//		p2	ItZbg
//		p3	őMTCY
//		p4	\Pbgnh
EXPORT BOOL WINAPI tcprecv(char *p1, int p2, int p3, int p4)
{
	THREADLIST *tl = (LPTHREADLIST)p4;
	THREADINFO *ti;
	int n;
	if (! IsSocketHandle(tl, ST_TCP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return 0;

	/*  `FbNT  */
	if (p2 < 0 || p3 < 0) return 0;

	ti = tl->ti;
	ti->Lock();
	n = ti->tcp.r->Read(p1+p2, p3);
	ti->Unlock();
	return -n;
}


// TCP\PbgPeek
//		p1	ϐ
//		p2	ItZbg
//		p3	őMTCY
//		p4	\Pbgnh
EXPORT BOOL WINAPI tcppeek(char *p1, int p2, int p3, int p4)
{
	THREADLIST *tl = (LPTHREADLIST)p4;
	THREADINFO *ti;
	int n;
	if (! IsSocketHandle(tl, ST_TCP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return 0;

	/*  `FbNT  */
	if (p2 < 0 || p3 < 0) return 0;

	ti = tl->ti;
	ti->Lock();
	n = ti->tcp.r->Peek(p1+p2, p3);
	ti->Unlock();
	return -n;
}


// TCP\PbgWrite
//		p1	ϐ
//		p2	ItZbg
//		p3	MTCY
//		p4	\Pbgnh
EXPORT BOOL WINAPI tcpsend(char *p1, int p2, int p3, int p4)
{
	THREADLIST *tl = (LPTHREADLIST)p4;
	THREADINFO *ti;
	if (! IsSocketHandle(tl, ST_TCP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -2;

	/*  `FbNT  */
	if (p2 < 0 || p3 < 0) return 0;

	ti = tl->ti;
	ti->Lock();
	/*
	if (ti->tcp.s->Count() + p3 > iMaxBuffer) {
		ti->Unlock();
		SendMessage(tl->hWnd, WM_FATAL_CLOSE, WSAENOBUFS, 0);
		return -1;
	}
	*/
	if (! ti->tcp.bAvailable) {
		ti->Unlock();
		return -1;
	}
	if (ti->tcp.bShutting) {
		ti->Unlock();
		return -1;
	}
	ti->tcp.s->Write(p1+p2, p3);
	ti->Unlock();
	PostMessage(tl->hWnd, WM_SENDING, 0, 0);
	return 0;
}


// TCP\PbgCount(r)
//		p1	lϐ
//		p2	\Pbgnh
EXPORT BOOL WINAPI tcpcount(int *p1, int p2, int p3, int p4)
{
	*p1 = 0;
	THREADLIST *tl = (LPTHREADLIST)p2;
	THREADINFO *ti;
	if (! IsSocketHandle(tl, ST_TCP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -1;

	ti = tl->ti;
	ti->Lock();
	*p1 = ti->tcp.r->Count();
	ti->Unlock();
	return 0;
}


// TCP\PbgCount(s)
//		p1	lϐ
//		p2	\Pbgnh
EXPORT BOOL WINAPI tcpqueue(int *p1, int p2, int p3, int p4)
{
	*p1 = 0;
	THREADLIST *tl = (LPTHREADLIST)p2;
	THREADINFO *ti;
	if (! IsSocketHandle(tl, ST_TCP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -1;

	ti = tl->ti;
	ti->Lock();
	*p1 = ti->tcp.s->Count();
	ti->Unlock();
	return 0;
}


// TCP\PbgWrite
//		p1	
//		p2	\Pbgnh
EXPORT BOOL WINAPI tcpput(BMSCR *bm, char *p1, int p2, int p3)
{
	return tcpsend(p1, 0, strlen(p1), p2);
}
// TCP\PbgRead
//		p1	i[ϐ
//		p2  ϐ̃TCY
//		p3	\Pbgnh
EXPORT BOOL WINAPI tcpget(char *p1, int p2, int p3, int p4)
{
	/*  `FbNT  */
	if (p2 < 0) return 0;

	BOOL ret = tcprecv(p1, 0, p2-1, p3);
	p1[-ret] = '\0';
	return ret;
}


// TCP\PbgWrite(c/w/d)
//		p1	lϐ
//		p2	\Pbgnh
EXPORT BOOL WINAPI tcpputc(int p1, int p2, int p3, int p4)
{
	return tcpsend((char *)&p1, 0, 1, p2);
}
EXPORT BOOL WINAPI tcpputw(int p1, int p2, int p3, int p4)
{
	return tcpsend((char *)&p1, 0, 2, p2);
}
EXPORT BOOL WINAPI tcpputd(int p1, int p2, int p3, int p4)
{
	return tcpsend((char *)&p1, 0, 4, p2);
}


// TCP\PbgRead(c/w/d)
//		p1	lϐ
//		p2	\Pbgnh
EXPORT BOOL WINAPI tcpgetc(int *p1, int p2, int p3, int p4)
{
	if (! IsSocketHandle((LPTHREADLIST)p2, ST_TCP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -2;
	*p1 = 0;
	int len;
	tcpcount(&len, p2, 0, 0);
	if (len < 1) return -1;
	tcprecv((char *)p1, 0, 1, p2);
	return 0;
}
EXPORT BOOL WINAPI tcpgetw(int *p1, int p2, int p3, int p4)
{
	if (! IsSocketHandle((LPTHREADLIST)p2, ST_TCP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -2;
	*p1 = 0;
	int len;
	tcpcount(&len, p2, 0, 0);
	if (len < 2) return -1;
	tcprecv((char *)p1, 0, 2, p2);
	return 0;
}
EXPORT BOOL WINAPI tcpgetd(int *p1, int p2, int p3, int p4)
{
	if (! IsSocketHandle((LPTHREADLIST)p2, ST_TCP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -2;
	*p1 = 0;
	int len;
	tcpcount(&len, p2, 0, 0);
	if (len < 4) return -1;
	tcprecv((char *)p1, 0, 4, p2);
	return 0;
}


// TCP\PbgPeek(c/w/d)
//		p1	lϐ
//		p2	\Pbgnh
EXPORT BOOL WINAPI tcppeekc(int *p1, int p2, int p3, int p4)
{
	if (! IsSocketHandle((LPTHREADLIST)p2, ST_TCP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -2;
	*p1 = 0;
	int len;
	tcpcount(&len, p2, 0, 0);
	if (len < 1) return -1;
	tcppeek((char *)p1, 0, 1, p2);
	return 0;
}
EXPORT BOOL WINAPI tcppeekw(int *p1, int p2, int p3, int p4)
{
	if (! IsSocketHandle((LPTHREADLIST)p2, ST_TCP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -2;
	*p1 = 0;
	int len;
	tcpcount(&len, p2, 0, 0);
	if (len < 2) return -1;
	tcppeek((char *)p1, 0, 2, p2);
	return 0;
}
EXPORT BOOL WINAPI tcppeekd(int *p1, int p2, int p3, int p4)
{
	if (! IsSocketHandle((LPTHREADLIST)p2, ST_TCP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -2;
	*p1 = 0;
	int len;
	tcpcount(&len, p2, 0, 0);
	if (len < 4) return -1;
	tcppeek((char *)p1, 0, 4, p2);
	return 0;
}


// sM
//		p1	Mϐ
//		p2	őMTCY
//		p3	\Pbgnh
EXPORT BOOL WINAPI tcpgetl(char *p1, int p2, int p3, int p4)
{
	*p1 = '\0';
	THREADLIST *tl = (LPTHREADLIST)p3;
	THREADINFO *ti;
	if (! IsSocketHandle(tl, ST_TCP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return 0;

	/*  `FbNT  */
	if (p2 < 0) return 0;
	if (p2 == 0) p2 = 64;

	int len;
	char *buf;
	int i, ret;

	ti = tl->ti;
	ti->Lock();

	len = ti->tcp.r->Count();
	if (len == 0) {
		ti->Unlock();
		return 0;
	}
	buf = new char[len+1];
	ti->tcp.r->Peek(buf, len);
	buf[len] = '\0';

	ret=0;
	for(i=0; i<(int)len; i++) {
		if ( buf[i]==0x0d && buf[i+1]==0x0a ) {
			ret = i+2;
			ti->tcp.r->Read(NULL, ret);
			if (i >= p2) i = p2-1;
			memcpy(p1, buf, i);
			p1[i] = '\0';
			break;
		}
		if ( buf[i] == 0x0a || buf[i] == 0x00 ) {
			ret = i+1;
			ti->tcp.r->Read(NULL, ret);
			if (i >= p2) i = p2-1;
			memcpy(p1, buf, i);
			p1[i] = '\0';
			break;
		}
		if ( buf[i] == 0x0d ) {
			if ( i != len-1 || (ti->err != 0) ) {
				ret = i+1;
				ti->tcp.r->Read(NULL, ret);
				if (i >= p2) i = p2-1;
				memcpy(p1, buf, i);
				p1[i] = '\0';
				break;
			}
		}
	}
	if (ret == 0 && len > 0 && (ti->err != 0) ) {
		ret = len;
		ti->tcp.r->Read(NULL, ret);
		memcpy(p1, buf, len);
		p1[len] = '\0';
	}
	delete [] buf;

	ti->Unlock();
	return -ret;
}




// TCP\Pbg̏擾
//		p1	ϐ
//		p2	\Pbgnh
EXPORT BOOL WINAPI tcpinfo(char *p1, int p2, int p3, int p4)
{
	*p1 = '\0';
	THREADLIST *tl = (LPTHREADLIST)p2;
	THREADINFO *ti;
	if (! IsSocketHandle(tl, ST_TCP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -1;

	struct in_addr inaddr;
	char *p, s[16];

	ti = tl->ti;
	ti->Lock();
	inaddr.s_addr = ti->tcp.addr;
	p = inet_ntoa(inaddr);
	if (p == NULL) {
		ti->Unlock();
		return -2;
	}
	strcpy(p1, p);
	_itoa((int)ntohs(ti->tcp.port), s, 10);
	strcat(p1, ":");
	strcat(p1, s);
	ti->Unlock();
	return 0;
}



// TCP\PbgLocalPort擾
//		p1	lϐ
//		p2	\Pbgnh
EXPORT BOOL WINAPI tcpport(int *p1, int p2, int p3, int p4)
{
	*p1 = 0;
	THREADLIST *tl = (LPTHREADLIST)p2;
	THREADINFO *ti;
	if (! IsSocketHandle(tl, ST_TCPALL))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -1;

	struct sockaddr_in addr;
	int len = sizeof(addr);

	ti = tl->ti;
	ti->Lock();
	getsockname(ti->soc, (struct sockaddr *)&addr, &len);
	*p1 = (int)ntohs(addr.sin_port);
	ti->Unlock();
	return 0;
}



/*
// TCP\PbgBlockingԂ擾
//		p1	\Pbgnh
EXPORT BOOL WINAPI tcpsent(int p1, int p2, int p3, int p4)
{
	THREADLIST *tl = (LPTHREADLIST)p1;
	THREADINFO *ti;
	if (! IsSocketHandle(tl, ST_TCP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -2;

	BOOL bBlocking;

	ti = tl->ti;
	ti->Lock();
	bBlocking = ti->tcp.bBlocking;
	ti->Unlock();
	return bBlocking ? 0 : -1;
}
//*/


// TCP\Pbg̑M~
//		p1	\Pbgnh
EXPORT BOOL WINAPI tcpshut(int p1, int p2, int p3, int p4)
{
	THREADLIST *tl = (LPTHREADLIST)p1;
	THREADINFO *ti;
	if (! IsSocketHandle(tl, ST_TCP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -1;

	ti = tl->ti;
	ti->Lock();
	ti->tcp.bShutting = TRUE;
	ti->tcp.bAvailable = FALSE;
	ti->Unlock();
	PostMessage(tl->hWnd, WM_SENDING, 0, 0);
	return 0;
}




////////////////////////////////////////////////////////////////////////////////


// TCP\Pbg쐬Aڑҋ@
//		p1	\Pbgnhi[ϐ
//		p2	|[g
EXPORT BOOL WINAPI tcpmake(int *p1, int p2, int p3, int p4)
{
	*p1 = 0;
	if ( InitWSA() ) return -1;		// WinSockG[

	/*  `FbNT  */
	if (p2 < 0 || p2 >= 65536) return 0;

	THREADLIST *tl;
	tl = CreateSocketThread(ST_TCPLISTEN);
	if (tl == NULL)
		return -2;			//	ThreadG[

	if ( SendMessage(tl->hWnd, WM_BIND, (WPARAM)p2, 0) != 0 ) {
		DeleteThread(tl);
		return -1;
	}

	*p1 = (int)tl;
	return 0;
}


// TCPLISTEN\PbgɐڑvĂ邩H
//		p1	\Pbgnh
EXPORT BOOL WINAPI tcpwait(int p1, int p2, int p3, int p4)
{
	THREADLIST *tl = (LPTHREADLIST)p1;
	THREADINFO *ti;

	if (! IsSocketHandle(tl, ST_TCPLISTEN))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -2;

	BOOL incoming;
	ti = tl->ti;
	incoming = ti->tcp.incoming;

	return -incoming;
}


// TCPLISTEN\PbgŐڑ
//		p1	\Pbgnhi[ϐ
//		p2	\Pbgnh
EXPORT BOOL WINAPI tcpaccept(int *p1, int p2, int p3, char *refstr)
{
	*p1 = 0;
	THREADLIST *tl = (LPTHREADLIST)p2;
	THREADINFO *ti;
	if (! IsSocketHandle(tl, ST_TCPLISTEN))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -1;

	ACCEPTSTRUCT acc;
	THREADLIST *newtl;
	char s[64];

	ti = tl->ti;
	ti->Lock();
	if (! ti->tcp.incoming) {
		ti->Unlock();
		return -2;
	}
	ti->Unlock();

	if (SendMessage(tl->hWnd, WM_ACCEPT, 0, (LPARAM)&acc))
		return -4;
	newtl = CreateSocketThread(ST_TCP);
	if (newtl == NULL)
		return -3;

	SendMessage(newtl->hWnd, WM_SOCKATTACH, (WPARAM)acc.soc, 0);

	ti = newtl->ti;
	ti->Lock();
	ti->tcp.addr = acc.from.sin_addr.s_addr;
	ti->tcp.port = acc.from.sin_port;
	ti->Unlock();

	strcpy(refstr, inet_ntoa(acc.from.sin_addr));
	strcat(refstr, ":");
	strcat(refstr, _itoa((int)ntohs(acc.from.sin_port), s, 10));

	*p1 = (int)newtl;
	return 0;
}
















// TCP\Pbgdiscard
//		p1	TCY
//		p2	\Pbgnh
EXPORT BOOL WINAPI tcpdisc(int p1, int p2, int p3, int p4)
{
	THREADLIST *tl = (LPTHREADLIST)p2;
	THREADINFO *ti;
	int n;
	if (! IsSocketHandle(tl, ST_TCP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return 0;

	/*  `FbNT  */
	if (p1 < 0) return 0;

	ti = tl->ti;
	ti->Lock();
	n = ti->tcp.r->Read(NULL, p1);
	ti->Unlock();
	return -n;
}